std::filesystem::directory_entry::replace_filename(3)

NAME
std::filesystem::directory_entry::replace_filename - std::filesystem::directory_entry::replace_filename

Synopsis
   void replace_filename( const std::filesystem::path& p );
   void replace_filename( const std::filesystem::path& p, (since C++17)
   std::error_code& ec );
   Changes the filename of the directory entry.
   Effectively modifies the path member by path.replace_filename(p) and calls refresh
   to update the cached attributes. If an error occurs, the values of the cached
   attributes are unspecified.
   This function does not commit any changes to the filesystem.

Parameters
   p - the path to append to the parent path of the currently stored path
   ec - out-parameter for error reporting in the non-throwing overload

Return value
   (none)

Exceptions
   The overload that does not take a std::error_code& parameter throws
   filesystem::filesystem_error on underlying OS API errors, constructed with p as the
   first path argument and the OS error code as the error code argument. The overload
   taking a std::error_code& parameter sets it to the OS API error code if an OS API
   call fails, and executes ec.clear() if no errors occur. Any overload not marked
   noexcept may throw std::bad_alloc if memory allocation fails.

Example
// Run this code
 #include <iostream>
 #include <filesystem>
 int main()
 {
     namespace fs = std::filesystem;
     {
         fs::directory_entry entry{ "omega" };
         std::cout << entry << '\n';
         entry.replace_filename("alpha");
         std::cout << entry << '\n';
     }{
         fs::directory_entry entry{ "/omega/" };
         std::cout << entry << '\n';
         entry.replace_filename("alpha");
         std::cout << entry << '\n';
     }
 }

Output:
 "omega"
 "alpha"
 "/omega/"
 "/omega/alpha"

See also
   assign assigns contents
                    (public member function)
   replace_filename replaces the last path component with another path
                    (public member function of std::filesystem::path)